--
-- rabab
--
-- handbremse
--
-- @author ???
--
-- @complement by Amarlich (16.01.2013)
--

rabab = {};

function rabab.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function rabab:load(xmlFile)
	self.setrababState = SpecializationUtil.callSpecializationsFunction("setrababState");
	self.rababHud = Overlay:new("hBOverlay", Utils.getFilename("texturRaba/symbol.dds", self.baseDirectory), 0.785, 0.250, 0.040, 0.050);
	
	self.rabab = true;
    
	rababSoundFile = Utils.getFilename("sounds/rabab_up.wav", self.baseDirectory);
    self.rababSoundId = createSample("rababSound");
    loadSample(self.rababSoundId, rababSoundFile, false);
    self.rababPlaying = false;
	
	rababReleaseSoundFile = Utils.getFilename("sounds/rabab_down.wav", self.baseDirectory);
    self.rababReleaseSoundId = createSample("rababReleaseSound");
    loadSample(self.rababReleaseSoundId, rababReleaseSoundFile, false);
    self.rababReleasePlaying = false;

	brakeSoundFile = Utils.getFilename("sounds/empty.wav", self.baseDirectory);
    self.brakeSoundId = createSample("brakeSound");
    loadSample(self.brakeSoundId, brakeSoundFile, false);
    self.brakePlaying = false;
	
	brakereleaseSoundFile = Utils.getFilename("sounds/empty.wav", self.baseDirectory);
    self.brakereleaseSoundId = createSample("brakereleaseSound");
    loadSample(self.brakereleaseSoundId, brakereleaseSoundFile, false);
    
	self.brakereleasePlaying = false;
    self.BreakForceVal = 10000/self.motor.brakeForce;

    self.rababTurnOff = false;
end;

function rabab:delete()

end;

function rabab:mouseEvent(posX, posY, isDown, isUp, button)

end;

function rabab:keyEvent(unicode, sym, modifier, isDown)
    if isDown and sym == Input.KEY_space then
		self:setrababState(not self.rabab);
		if self.rabab and self:getIsActiveForSound() then
			playSample(self.rababSoundId,1,1,0);
		end;
	end;
    if not isDown and sym == Input.KEY_space then
		self:setrababState(self.rabab);
		if not self.rabab and self:getIsActiveForSound() then
			playSample(self.rababReleaseSoundId,1,1,0);
		end;
	end;
end;

function setrababState(state, noEventSend)
rababEvent.sendEvent(self, state, noEventSend); -- MP Fix by modelleicher, addet Event
    self.rabab = state;
    self.rababTurnOff = state;
    setVisibility(self.rabablight, state);
end;

function rabab:updateTick(dt)
   if self.isServer then
        if self.rabab then
            if self.isServer then
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 9, 0);
                end;
            end;
        elseif not self.rabab and self.rababTurnOff then
            if self.isServer then
                for k,wheel in pairs(self.wheels) do
                    setWheelShapeProps(wheel.node, wheel.wheelShape, 0, 0, 0);
                end;
            end;
            self.rababTurnOff = false;
        end;
    end;
end;

function rabab:update(dt)

	if self.isMotorStarted then        
		if Input.isKeyPressed(Input.KEY_s) then
				if not self.braking then
					self.braking = true;
				end;
				if not self.brakePlaying and self:getIsActiveForSound() then
					playSample(self.brakeSoundId,1,1,0);
					self.brakePlaying = true;
				end;
				self.brakereleasePlaying = false;				
		else
			self.brakePlaying = false;
			self.braking = false;
			if not self.brakereleasePlaying and self:getIsActiveForSound() then
				playSample(self.brakereleaseSoundId,1,1,0);
				self.brakereleasePlaying = true;
			end;
		end;
	end;
end;

function rabab:draw()
	if self.isEntered then	
		if self.rabab then
			if Input.isKeyPressed(Input.KEY_w) then
				self.rababHud:render();
			end;
		self.rababHud:render();
		end;
		end;
		if self.rabab == false then
		g_currentMission:addHelpButtonText(g_i18n:getText("rababON"), InputBinding.rabab);
		else
		g_currentMission:addHelpButtonText(g_i18n:getText("rababOFF"), InputBinding.rabab);
	end;
	if self.isEntered then	
		if self.rabab then
			if Input.isKeyPressed(Input.KEY_w) then
				g_currentMission:addWarning(g_i18n:getText("rababRELEASE"), 0.015, 0.030);
			end;
		end;
	end;
	if self.isEntered then	
		if self.rabab then
			if Input.isKeyPressed(Input.KEY_s) then
				g_currentMission:addWarning(g_i18n:getText("rababRELEASE"), 0.015, 0.030);
			end;
		end;
	end;
end;

function rabab:onLeave()

end;

function rabab:setrababState(state, noEventSend)
    self.rabab = state;
    self.rababTurnOff = state;
end;

-- rabab EVENT --
-- MP Fix by modelleicher
rababEvent = {};
rababEvent_mt = Class(rababEvent, Event);

InitEventClass(rababEvent, "rababEvent");

function rababEvent:emptyNew()
    local self = Event:new(rababEvent_mt);
    self.className = "rababEvent";
    return self;
end;

function rababEvent:new(object, state)
    local self = rababEvent:emptyNew()
    self.object = object;
	self.state = state;
    return self;
end;

function rababEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function rababEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteBool(streamId, self.state);
end;

function rababEvent:run(connection)
    self.object:setrababState(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(rababEvent:new(self.object, self.state), nil, connection, self.object);
    end;
end;

function rababEvent.sendEvent(vehicle, state, noEventSend)
    if state ~= vehicle.rabab then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(rababEvent:new(vehicle, state), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(rababEvent:new(vehicle, state));
            end;
        end;
    end;
end;